﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.Json;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

using Microsoft.OpenApi;
using Microsoft.OpenApi.Any;
using Microsoft.OpenApi.Extensions;
using Microsoft.OpenApi.Models;

using Swashbuckle.AspNetCore.SwaggerGen;

namespace SwaggerStudy
{
    public class TagDescriptionsDocumentFilter : IDocumentFilter
    {
        public void Apply(OpenApiDocument swaggerDoc, DocumentFilterContext context)
        {
            //输出整个SwaggerDoc为Json字符串
            var JSON = JsonSerializer.Serialize(swaggerDoc, SystemTextJsonOption.DefaultJsonSerializerOptions);
            Console.WriteLine(JSON);

            swaggerDoc.Tags = new List<OpenApiTag> 
            {
                new OpenApiTag { Name = "Products", Description = "Browse/manage the product catalog" },
                new OpenApiTag { Name = "Orders", Description = "Submit orders" }
            };
        }
    }
}
